(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('prop-types'), require('classnames')) :
	typeof define === 'function' && define.amd ? define(['exports', 'react', 'prop-types', 'classnames'], factory) :
	(factory((global.ReactTabs = {}),global.React,global.PropTypes,global.classnames));
}(this, (function (exports,React,PropTypes,classnames) { 'use strict';

var React__default = 'default' in React ? React['default'] : React;
PropTypes = PropTypes && PropTypes.hasOwnProperty('default') ? PropTypes['default'] : PropTypes;
classnames = classnames && classnames.hasOwnProperty('default') ? classnames['default'] : classnames;

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};









var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};











var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var DefaultDelimiter = function (_React$Component) {
  inherits(DefaultDelimiter, _React$Component);

  function DefaultDelimiter() {
    classCallCheck(this, DefaultDelimiter);
    return possibleConstructorReturn(this, _React$Component.apply(this, arguments));
  }

  DefaultDelimiter.prototype.render = function render() {
    return null;
  };

  return DefaultDelimiter;
}(React__default.Component);

var InputRange = function (_Component) {
  inherits(InputRange, _Component);

  function InputRange() {
    var _temp, _this2, _ret;

    classCallCheck(this, InputRange);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this2 = possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this2), _this2.state = {
      from: _this2.props.from,
      to: _this2.props.to
    }, _this2.onChange = function (event) {
      var _babelHelpers$extends;

      var newState = _extends({}, _this2.state, (_babelHelpers$extends = {}, _babelHelpers$extends[event.target.name] = event.target.value, _babelHelpers$extends));

      _this2.setState(newState);
      _this2.props.onChange(newState);
    }, _temp), possibleConstructorReturn(_this2, _ret);
  }

  InputRange.prototype.componentDidUpdate = function componentDidUpdate(prevProps) {
    if (prevProps.from !== this.props.from) {
      this.setState({ from: this.props.from });
    }

    if (prevProps.to !== this.props.to) {
      this.setState({ to: this.props.to });
    }
  };

  InputRange.prototype.render = function render() {
    var _props = this.props,
        className = _props.className,
        Delimiter = _props.Delimiter;
    var _state = this.state,
        to = _state.to,
        from = _state.from;


    var fromProps = {
      name: 'from',
      className: 'input-range__from',
      value: from,
      onChange: this.onChange
    };

    var toProps = {
      name: 'to',
      className: 'input-range__to',
      value: to,
      onChange: this.onChange
    };

    return React__default.createElement(
      'div',
      { className: classnames('input-range', className) },
      React__default.createElement('input', fromProps),
      React__default.createElement(
        'div',
        { className: 'input-range__delimiter' },
        React__default.createElement(Delimiter, null)
      ),
      React__default.createElement('input', toProps)
    );
  };

  return InputRange;
}(React.Component);

InputRange.displayName = 'InputRange';
InputRange.propTypes = {
  className: PropTypes.string,
  to: PropTypes.string.isRequired,
  from: PropTypes.string.isRequired,
  onChange: PropTypes.func,
  Delimiter: PropTypes.func
};
InputRange.defaultProps = {
  onChange: function onChange() {},
  Delimiter: DefaultDelimiter
};

exports.InputRange = InputRange;

Object.defineProperty(exports, '__esModule', { value: true });

})));
